// Package models provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package models

import (
	"encoding/json"
	"errors"
	"fmt"

	"github.com/oapi-codegen/runtime"
)

// Defines values for DestinationType.
const (
	DESTINATIONTYPEDELEGATEDDESTINATION DestinationType = "DESTINATION_TYPE_DELEGATED_DESTINATION"
	DESTINATIONTYPEDESTINATION          DestinationType = "DESTINATION_TYPE_DESTINATION"
)

// Defines values for LogRecordDirection.
const (
	LogRecordDirectionDIRECTIONINCOMING LogRecordDirection = "DIRECTION_INCOMING"
	LogRecordDirectionDIRECTIONOUTGOING LogRecordDirection = "DIRECTION_OUTGOING"
)

// Defines values for MetadataDirection.
const (
	MetadataDirectionDIRECTIONINCOMING MetadataDirection = "DIRECTION_INCOMING"
	MetadataDirectionDIRECTIONOUTGOING MetadataDirection = "DIRECTION_OUTGOING"
)

// Defines values for SortOrder.
const (
	SORTORDERASCENDING  SortOrder = "SORT_ORDER_ASCENDING"
	SORTORDERDESCENDING SortOrder = "SORT_ORDER_DESCENDING"
)

// Defines values for SourceType.
const (
	SOURCETYPEDELEGATEDSOURCE SourceType = "SOURCE_TYPE_DELEGATED_SOURCE"
	SOURCETYPESOURCE          SourceType = "SOURCE_TYPE_SOURCE"
)

// Destination Details of the Peer offering the Service
type Destination struct {
	// ServicePeerId The ID of a Peer
	ServicePeerId PeerID          `json:"service_peer_id"`
	Type          DestinationType `json:"type"`
}

// DestinationDelegated Details of the Peer offering the Service and the Delegator
type DestinationDelegated struct {
	// DelegatorPeerId The ID of a Peer
	DelegatorPeerId PeerID `json:"delegator_peer_id"`

	// ServicePeerId The ID of a Peer
	ServicePeerId PeerID          `json:"service_peer_id"`
	Type          DestinationType `json:"type"`
}

// DestinationType defines model for destinationType.
type DestinationType string

// Error Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type Error struct {
	// Details Human-readable explanation specific to this occurrence of the problem.
	// The "detail" string, if present, ought to focus on helping the client correct the problem, rather than giving debugging information.
	Details string `json:"details"`

	// Instance URI reference that identifies the specific occurrence of the problem.
	Instance string `json:"instance"`

	// Status HTTP status code generated by the origin server for this occurrence of the problem.
	Status int `json:"status"`

	// Title Short, human-readable summary of the problem type.
	Title string `json:"title"`

	// Type URI reference that identifies the problem type.
	Type string `json:"type"`
}

// GrantHash The hash of a Grant
type GrantHash = string

// GroupID The FSC Group ID (Directory URI)
type GroupID = string

// LogRecord A log record
type LogRecord struct {
	// CreatedAt A Unix timestamp
	CreatedAt   Timestamp             `json:"created_at"`
	Destination LogRecord_Destination `json:"destination"`

	// Direction The direction of a request. I.e. is the request being send or received
	Direction LogRecordDirection `json:"direction"`

	// GrantHash The hash of a Grant
	GrantHash GrantHash `json:"grant_hash"`

	// GroupId The FSC Group ID (Directory URI)
	GroupId GroupID `json:"group_id"`

	// ServiceName The name of a service
	ServiceName ServiceName      `json:"service_name"`
	Source      LogRecord_Source `json:"source"`

	// TransactionId UUID v7
	TransactionId Uuid `json:"transaction_id"`
}

// LogRecord_Destination defines model for LogRecord.Destination.
type LogRecord_Destination struct {
	union json.RawMessage
}

// LogRecordDirection The direction of a request. I.e. is the request being send or received
type LogRecordDirection string

// LogRecord_Source defines model for LogRecord.Source.
type LogRecord_Source struct {
	union json.RawMessage
}

// Metadata defines model for metadata.
type Metadata struct {
	// Direction The direction of a request. I.e. is the request being send or received
	Direction MetadataDirection `json:"direction"`

	// GroupId The FSC Group ID (Directory URI)
	GroupId GroupID `json:"group_id"`

	// TransactionId UUID v7
	TransactionId        Uuid                              `json:"transaction_id"`
	AdditionalProperties map[string]map[string]interface{} `json:"-"`
}

// MetadataDirection The direction of a request. I.e. is the request being send or received
type MetadataDirection string

// PaginationResult defines model for paginationResult.
type PaginationResult struct {
	// NextCursor A cursor that can be used to retrieve the next page or an empty string if there are no more results
	NextCursor string `json:"next_cursor"`
}

// PeerID The ID of a Peer
type PeerID = string

// ServiceName The name of a service
type ServiceName = string

// SortOrder The order in which the results should be returned
type SortOrder string

// Source Details of the Peer initiating the request
type Source struct {
	// OutwayPeerId The ID of a Peer
	OutwayPeerId PeerID     `json:"outway_peer_id"`
	Type         SourceType `json:"type"`
}

// SourceDelegated Details of the Peer initiating the request and the Delegator
type SourceDelegated struct {
	// DelegatorPeerId The ID of a Peer
	DelegatorPeerId PeerID `json:"delegator_peer_id"`

	// OutwayPeerId The ID of a Peer
	OutwayPeerId PeerID     `json:"outway_peer_id"`
	Type         SourceType `json:"type"`
}

// SourceType defines model for sourceType.
type SourceType string

// Timestamp A Unix timestamp
type Timestamp = int64

// Uuid UUID v7
type Uuid = string

// QueryPaginationCursor defines model for queryPaginationCursor.
type QueryPaginationCursor = string

// QueryPaginationLimit defines model for queryPaginationLimit.
type QueryPaginationLimit = uint32

// QueryPaginationOrder The order in which the results should be returned
type QueryPaginationOrder = SortOrder

// N400BadRequest Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N400BadRequest = Error

// N401Unauthorized Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N401Unauthorized = Error

// N403Forbidden Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N403Forbidden = Error

// N404NotFound Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N404NotFound = Error

// N408RequestTimeout Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N408RequestTimeout = Error

// N413PayloadTooLarge Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N413PayloadTooLarge = Error

// N414URITooLong Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N414URITooLong = Error

// N422UnprocessableEntity Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N422UnprocessableEntity = Error

// N429TooManyRequests Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N429TooManyRequests = Error

// N431RequestHeaderFieldsTooLarge Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N431RequestHeaderFieldsTooLarge = Error

// N500InternalServerError Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N500InternalServerError = Error

// N503ServiceUnavailable Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N503ServiceUnavailable = Error

// N505HTTPVersionNotSupported Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N505HTTPVersionNotSupported = Error

// CreateMetadataRecordsJSONBody defines parameters for CreateMetadataRecords.
type CreateMetadataRecordsJSONBody struct {
	// Records List of Metadata records
	Records []Metadata `json:"records"`
}

// GetLogRecordsParams defines parameters for GetLogRecords.
type GetLogRecordsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page
	Cursor *QueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *QueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// After Log records with a creation date after this value will be returned
	After *Timestamp `form:"after,omitempty" json:"after,omitempty"`

	// Before Log records with a creation date before this value will be returned
	Before *Timestamp `form:"before,omitempty" json:"before,omitempty"`

	// GroupId Get the log records for this group.
	GroupId GroupID `form:"group_id" json:"group_id"`

	// GrantHash A list of Grant hashes on which to filter. When multiple filters are used the records where either condition is true should be returned
	GrantHash *[]GrantHash `form:"grant_hash,omitempty" json:"grant_hash,omitempty"`

	// ServiceName A list of service names on which to filter. When multiple filters are used the records where either condition is true should be returned
	ServiceName *[]ServiceName `form:"service_name,omitempty" json:"service_name,omitempty"`

	// TransactionIds A list of transaction IDs on which to filter. When this query parameter is set the pagination parameters and other filters should be ignored
	TransactionIds *[]Uuid `form:"transaction_ids,omitempty" json:"transaction_ids,omitempty"`

	// PeerId A list of peer IDs on which to filter
	PeerId *[]PeerID `form:"peer_id,omitempty" json:"peer_id,omitempty"`
}

// CreateLogRecordsJSONBody defines parameters for CreateLogRecords.
type CreateLogRecordsJSONBody struct {
	// Records List of log records
	Records []LogRecord `json:"records"`
}

// CreateMetadataRecordsJSONRequestBody defines body for CreateMetadataRecords for application/json ContentType.
type CreateMetadataRecordsJSONRequestBody CreateMetadataRecordsJSONBody

// CreateLogRecordsJSONRequestBody defines body for CreateLogRecords for application/json ContentType.
type CreateLogRecordsJSONRequestBody CreateLogRecordsJSONBody

// Getter for additional properties for Metadata. Returns the specified
// element and whether it was found
func (a Metadata) Get(fieldName string) (value map[string]interface{}, found bool) {
	if a.AdditionalProperties != nil {
		value, found = a.AdditionalProperties[fieldName]
	}
	return
}

// Setter for additional properties for Metadata
func (a *Metadata) Set(fieldName string, value map[string]interface{}) {
	if a.AdditionalProperties == nil {
		a.AdditionalProperties = make(map[string]map[string]interface{})
	}
	a.AdditionalProperties[fieldName] = value
}

// Override default JSON handling for Metadata to handle AdditionalProperties
func (a *Metadata) UnmarshalJSON(b []byte) error {
	object := make(map[string]json.RawMessage)
	err := json.Unmarshal(b, &object)
	if err != nil {
		return err
	}

	if raw, found := object["direction"]; found {
		err = json.Unmarshal(raw, &a.Direction)
		if err != nil {
			return fmt.Errorf("error reading 'direction': %w", err)
		}
		delete(object, "direction")
	}

	if raw, found := object["group_id"]; found {
		err = json.Unmarshal(raw, &a.GroupId)
		if err != nil {
			return fmt.Errorf("error reading 'group_id': %w", err)
		}
		delete(object, "group_id")
	}

	if raw, found := object["transaction_id"]; found {
		err = json.Unmarshal(raw, &a.TransactionId)
		if err != nil {
			return fmt.Errorf("error reading 'transaction_id': %w", err)
		}
		delete(object, "transaction_id")
	}

	if len(object) != 0 {
		a.AdditionalProperties = make(map[string]map[string]interface{})
		for fieldName, fieldBuf := range object {
			var fieldVal map[string]interface{}
			err := json.Unmarshal(fieldBuf, &fieldVal)
			if err != nil {
				return fmt.Errorf("error unmarshaling field %s: %w", fieldName, err)
			}
			a.AdditionalProperties[fieldName] = fieldVal
		}
	}
	return nil
}

// Override default JSON handling for Metadata to handle AdditionalProperties
func (a Metadata) MarshalJSON() ([]byte, error) {
	var err error
	object := make(map[string]json.RawMessage)

	object["direction"], err = json.Marshal(a.Direction)
	if err != nil {
		return nil, fmt.Errorf("error marshaling 'direction': %w", err)
	}

	object["group_id"], err = json.Marshal(a.GroupId)
	if err != nil {
		return nil, fmt.Errorf("error marshaling 'group_id': %w", err)
	}

	object["transaction_id"], err = json.Marshal(a.TransactionId)
	if err != nil {
		return nil, fmt.Errorf("error marshaling 'transaction_id': %w", err)
	}

	for fieldName, field := range a.AdditionalProperties {
		object[fieldName], err = json.Marshal(field)
		if err != nil {
			return nil, fmt.Errorf("error marshaling '%s': %w", fieldName, err)
		}
	}
	return json.Marshal(object)
}

// AsDestination returns the union data inside the LogRecord_Destination as a Destination
func (t LogRecord_Destination) AsDestination() (Destination, error) {
	var body Destination
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDestination overwrites any union data inside the LogRecord_Destination as the provided Destination
func (t *LogRecord_Destination) FromDestination(v Destination) error {
	v.Type = "DESTINATION_TYPE_DESTINATION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDestination performs a merge with any union data inside the LogRecord_Destination, using the provided Destination
func (t *LogRecord_Destination) MergeDestination(v Destination) error {
	v.Type = "DESTINATION_TYPE_DESTINATION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsDestinationDelegated returns the union data inside the LogRecord_Destination as a DestinationDelegated
func (t LogRecord_Destination) AsDestinationDelegated() (DestinationDelegated, error) {
	var body DestinationDelegated
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDestinationDelegated overwrites any union data inside the LogRecord_Destination as the provided DestinationDelegated
func (t *LogRecord_Destination) FromDestinationDelegated(v DestinationDelegated) error {
	v.Type = "DESTINATION_TYPE_DELEGATED_DESTINATION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDestinationDelegated performs a merge with any union data inside the LogRecord_Destination, using the provided DestinationDelegated
func (t *LogRecord_Destination) MergeDestinationDelegated(v DestinationDelegated) error {
	v.Type = "DESTINATION_TYPE_DELEGATED_DESTINATION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t LogRecord_Destination) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t LogRecord_Destination) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "DESTINATION_TYPE_DELEGATED_DESTINATION":
		return t.AsDestinationDelegated()
	case "DESTINATION_TYPE_DESTINATION":
		return t.AsDestination()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t LogRecord_Destination) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *LogRecord_Destination) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsSource returns the union data inside the LogRecord_Source as a Source
func (t LogRecord_Source) AsSource() (Source, error) {
	var body Source
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromSource overwrites any union data inside the LogRecord_Source as the provided Source
func (t *LogRecord_Source) FromSource(v Source) error {
	v.Type = "SOURCE_TYPE_SOURCE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeSource performs a merge with any union data inside the LogRecord_Source, using the provided Source
func (t *LogRecord_Source) MergeSource(v Source) error {
	v.Type = "SOURCE_TYPE_SOURCE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsSourceDelegated returns the union data inside the LogRecord_Source as a SourceDelegated
func (t LogRecord_Source) AsSourceDelegated() (SourceDelegated, error) {
	var body SourceDelegated
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromSourceDelegated overwrites any union data inside the LogRecord_Source as the provided SourceDelegated
func (t *LogRecord_Source) FromSourceDelegated(v SourceDelegated) error {
	v.Type = "SOURCE_TYPE_DELEGATED_SOURCE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeSourceDelegated performs a merge with any union data inside the LogRecord_Source, using the provided SourceDelegated
func (t *LogRecord_Source) MergeSourceDelegated(v SourceDelegated) error {
	v.Type = "SOURCE_TYPE_DELEGATED_SOURCE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t LogRecord_Source) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t LogRecord_Source) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "SOURCE_TYPE_DELEGATED_SOURCE":
		return t.AsSourceDelegated()
	case "SOURCE_TYPE_SOURCE":
		return t.AsSource()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t LogRecord_Source) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *LogRecord_Source) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}
